package fucoin.configurations;

import akka.actor.ActorRef;
import fucoin.actions.control.ActionWalletSendMoney;
import fucoin.actions.transaction.ActionNotifyObserver;
import fucoin.configurations.internal.ConfigurationName;

/**
 * This configuration is the previous default of 2 wallets with GUI and a supervisor.
 */
@ConfigurationName("Default Configuration")
public class DefaultConfiguration extends AbstractConfiguration {

    @Override
    public void run() {
        initSupervisor();

        ActorRef wallet1 = null;
        ActorRef wallet2 = null;
        try {
            wallet1 = spawnWallet("Wallet0", false);
        } catch (Exception e) {
            System.out.println("Wallet0 spawning timed out");
        }
        try {
            wallet2 = spawnWallet("Wallet1", false);
        } catch (Exception e) {
            System.out.println("Wallet1 spawning timed out");
        }

        if (wallet1 != null && wallet2 != null) {
            wallet1.tell(new ActionWalletSendMoney(wallet2.path().name(), 50, getSelf()), wallet1);
        }
    }

    @Override
    public void onReceive(Object message) {
        if (message instanceof ActionNotifyObserver){
            ActionNotifyObserver notification = (ActionNotifyObserver) message;

            String status = "successful";
            if(! notification.granted){
                status = "failed";
            }

            System.out.println("Observed a " + status + " transaction of " + notification.amount+" FUCs from " +
                    notification.source.path().name() + " to " + notification.target.path().name());
        }

    }
}
